function easeInOutSine(x){
  return -(Math.cos(PI * x) - 1) / 2;
}


class gameProcess {

  constructor(){
    this.playerArray=[];
  for (let p=0; p<numPlayers; p++){
    //console.log(p + playerNames[p] + playerCols[p]);
  this.playerArray[p]=new player(p, playerNames[p], playerCols[p]);
  }
  this.whoseTurnNumber=0;
  this.whoseTurn=this.playerArray[this.whoseTurnNumber];



  }//end constructor;

  show(){
    if(HexGrid.wordList.length==0){
      this.endGame();
    }
  this.playerArray.forEach(h =>{
    h.show();
  });
//show scores
textAlign(LEFT, CENTER);
fill('white');
stroke('black');
strokeWeight(3);
textSize(32);
let listX=HexGrid.gridDrawWidth+30;
let animX=0;
text('SCORES', listX,HexGrid.gridDrawHeight-48);
for(let i=0; i<this.playerArray.length; i++){
  if(this.whoseTurn==this.playerArray[i]){
    fill(color(this.whoseTurn.playerColour));
    strokeWeight(5);
    angleMode(RADIANS);
    animX=sin(millis()/500)*2;
    //console.log(animX);
  }
  text(playerNames[i] + ': ' +this.playerArray[i].score,listX+animX, HexGrid.gridDrawHeight-8+(i*36));
  fill('white');
  strokeWeight(3);
  animX=0;
}
stroke('black');
  }

  resetGame(){
  this.playerArray.forEach(p=>{
p.i=gridSide+p.playerNumber;
  p.j=gridSide-p.playerNumber;
  let xy=hexToPixel(p.i,p.j);
  p.x=xy[0];
  p.y=xy[1];
  p.letterList=[];
  p.word=-1;
  p.letterHexList=[];
  p.score=0;
  p.status='playing';
  p.flying=false;
  p.z=0;
  });
}//end reset

turnover(){

  this.whoseTurn.endTurn();
  this.whoseTurnNumber+=1;
  this.whoseTurnNumber=floor(this.whoseTurnNumber % this.playerArray.length);
  this.whoseTurn=this.playerArray[this.whoseTurnNumber];
  if (this.whoseTurn.status=='ending turn'){
    this.whoseTurn.status='playing';
  }

}

endGame(){
  for(let i=0; i<this.playerArray.length; i++){
    this.playerArray[i].status='game over';
  }
  gameMode="game over";
}

}//end class

class player{
  constructor(num,name,colour){
  this.playerNumber=num;
  this.playerName=name;
  this.playerColour=color(colour);
  this.i=gridSide+this.playerNumber;
  this.j=gridSide-this.playerNumber;
  let xy=hexToPixel(this.i,this.j);
  this.x=xy[0];
  this.y=xy[1];
  this.letterList=[];
  this.word=-1;
  this.letterHexList=[];
  this.score=0;
  this.destinations=[];
  this.goNextIJ=[this.i, this.j];
  this.goNextXY=[this.x, this.y];
  this.speed=300;
  this.timeMoving=0;
  this.z=0;
  this.jumping=false;
  this.status='playing';
  }

  addHexLetter(hex){
    //console.log('add');
    if (this.letterHexList.length!=0){
      //already have some selected hexes
    let latestHex=this.letterHexList[this.letterHexList.length-1];
    let hexQueue=getLineBuddies(latestHex.i, latestHex.j, hex.i, hex.j);
    //console.log(hexQueue);
    if (hexQueue==-1){
      //-1 means not in line
      this.letterHexList.forEach(h=>{
        //clearing old hexes
    h.changeHexStatus('neutral');
    });
    //clearing player bits
    this.letterHexList=[];
    this.letterList=[];
    this.word=-1;
    this.destinations=[];
    //now add this hex
    this.letterList.push(hex.letter);
  this.word=join(this.letterList,'');
  this.letterHexList.push(hex);
  this.destinations.push([hex.i, hex.j]);

  this.howFar=0;

  hex.changeHexStatus('selected');
    }//end if not in line
    else {
      // if i  line, add the queue
      hexQueue.forEach(h=>{
   this.letterList.push(h.letter);
  this.word=join(this.letterList,'');
  //console.log(this.word);
  this.letterHexList.push(h);
  h.changeHexStatus('selected');
  this.destinations.push([h.i, h.j]);

    });
    }
  }//end if selected hexes;
  else{
    //this happens if no selected hexes
  this.letterList.push(hex.letter);
  this.word=join(this.letterList,'');

  this.letterHexList.push(hex);
  hex.changeHexStatus('selected');
  this.destinations.push([hex.i, hex.j]);

  }
}//end add letter

  dropHexLetter(hex){
  for (let i=this.letterHexList.length-1; i>-1; i--){
   let testHex=this.letterHexList[i];
    this.letterHexList.pop();
    this.letterList.pop();
    this.word=join(this.letterList,'');
    testHex.changeHexStatus('neutral');
    this.destinations.pop();
    if (testHex==hex){break};
  }
}//end drop letter

  checkWord(){
    //console.log(this);
if(this.status=='playing'){
    if (HexGrid.checkWord(this.word)){
      this.status='ending turn';
      this.jumping=true;
      //console.log('jumping', this.jumping);
      this.letterHexList.forEach(h => {
      h.live=false;
      gameMusicHandler.arpAdd(h.letter, gameMusicHandler.arpTrigger);
      });
      //console.log('get landing spot from ', this.letterHexList[this.letterHexList.length-1]);
      this.findLandingSpot(this.letterHexList[this.letterHexList.length-1]);
      this.score+=(this.letterList.length*5);
      HexGrid.deleteWord(this.word);
}
else if(useBigDictionary && HexGrid.bigDictCheck(this.word)){
  this.status='ending turn'
  this.jumping=true;
  gameMusicHandler.arpQ=[];
  this.letterHexList.forEach(h => {
  h.live=false;
  gameMusicHandler.arpAdd(h.letter, gameMusicHandler.arpTrigger);
  });
  //console.log('get landing spot from ', this.letterHexList[this.letterHexList.length-1]);
  this.findLandingSpot(this.letterHexList[this.letterHexList.length-1]);
  this.score+=(this.letterList.length*2);
  //HexGrid.deleteWord(this.word);
}
else {
  gameMusicHandler.playPing();
      gameP.turnover();
    }
  }
  }//end check word

  endTurn(){
    this.letterHexList=[];
  this.letterList=[];
  this.word=-1;
  for (let n=0; n<hexagons.length; n++){
    hexagons[n].forEach(h=>{
      if(h instanceof Hexagon){
    h.changeHexStatus('neutral');
  }
  });
}
  }

  clearWord(){
    if (this.status=='playing'){
      this.endTurn();
    }
  }

  checkHexforPath(){
    //if it's not a good hex, skip
    //console.log('nextIJ ',this.goNextIJ)
    if (this.goNextIJ==undefined){
      return false;
    }

    if(!CheckInGrid(this.goNextIJ[0], this.goNextIJ[1]) || !hexagons[this.goNextIJ[0]][this.goNextIJ[1]].live){
      this.goNextIJ=this.destinations.shift();
      //console.log('not on grid or not live');
    }
    if (!getNeighbours(this.i, this.j).includes(this.goNextIJ)){
      //console.log('not a neighbour');
      //find a path
      let path=pathfind(hexagons[this.i][this.j], hexagons[this.goNextIJ[0]][this.goNextIJ[1]]);
      //console.log(path);
      if (path!=false){
        //console.log(path);
      path.forEach(hex =>{
        this.destinations.unshift(hex);

      });
      return true;
    } else{
    //  console.log('no path')
      if (this.destinations.length>0){
        this.goNextIJ=this.destinations.shift();
    return  this.checkHexforPath();
  }
  this.flying=true;
  let howFarI=abs(this.goNextIJ[0]-this.i);
  let howFarJ=abs(this.goNextIJ[1]-this.j);
  let howFar=howFarI+howFarJ;
  this.score-=howFar;
  //console.log('flying');
  return false;
    }
  }
}//end check for pathfind

findLandingSpot(locus){
  //console.log('locus ',locus);
  for (let a=0; a<hexagons.length; a++){
    hexagons[a].forEach(h=>{
      if (h instanceof Hexagon){
    h.changeHexStatus('notGoodLanding');
  }
  });
}
let gotResults=false;
//console.log('gotResults ', gotResults);
resultsLoop: for(let n=1; n<(HexGrid.gridLength*2); n++){
  //console.log('n= ', n);
  //console.log('grid length ', HexGrid.gridLength);
let choices=getDistantNeighboursAsHexes(locus.i, locus.j, n);
//console.log('n= ', n);
//console.log('choices ', choices);
  if(choices.length>0){
    choices.forEach(h=>{

    if (h.live){
      //console.log('good h ' , h);
      h.changeHexStatus('goodLanding');
      gotResults=true;
    }
  });
  //console.log(gotResults);
  if (gotResults==true){
    break;
  }
}
}//end results loop
}//end find landing spot

  show(){
    //draw letter list if your turn
    if (gameP.whoseTurn==this){
    let wordHexHeight=HexGrid.gridDrawHeight+90;
    //draw letter list
    for (let i=0; i<this.letterHexList.length;i++){
    let h=this.letterHexList[i];
    let dx=90+(i*90);
    let points=MakeHexPoints(dx,wordHexHeight,45);
    DrawHex(dx, wordHexHeight, points, color('gainsboro'),4,this.playerColour);
    fill('white');
     stroke('black');
      strokeWeight(2);
      textSize(48);
      textAlign(CENTER,CENTER);
    text(h.letter,dx,wordHexHeight);
    }
  }
    //draw shadow
    let shadowC=color('black');
    shadowC.setAlpha(128);
    fill(shadowC);
    strokeWeight(2);
    stroke(color('black'));
    ellipse(this.x,this.y/gridYsquish+1, 50, 15);
    //draw triangle (placeholder)
  this.playerColour.setAlpha(175);
    fill(this.playerColour);
    stroke(color(0,0,0,200));
    strokeWeight(2);
    triangle(this.x-20, (this.y-this.z)/gridYsquish, this.x,((this.y-this.z)/gridYsquish)-60, this.x+20, (this.y-this.z)/gridYsquish);
    //get hex underneath and draw its letter back on top
    let ij=pixelToHex(this.x, this.y);
    this.i = ij[0];
    this.j = ij[1];
    let h = hexagons[this.i][this.j];
    push();
    scale(1, 1/gridYsquish);
    if (CheckInGrid(this.i,this.j)&&(h.live)){
      fill('white');
     stroke('black');
      strokeWeight(2);
      textSize(48);
      textAlign(CENTER,CENTER);
    text(h.letter,h.x,h.y);
    }
     pop();
     this.playerColour.setAlpha(255);
//check if floating
if((this==gameP.whoseTurn) && !(hexagons[this.i][this.j].live)
  && !(this.flying)
  && !(this.jumping)
  && (this.status=='playing')
  && (this.destinations.length==0)) {
    this.status='floating';
//console.log(gameP.playerArray);
  this.score-=10;
  this.findLandingSpot(hexagons[this.i][this.j]);
}
if(this==gameP.whoseTurn
  && hexagons[this.i][this.j].live
  && !(this.flying)
  && !(this.jumping)
  && this.status=='floating'
  && this.destinations.length==0){
    this.status="playing";
  }


     //movement
     if (this.destinations.length!=0){

       //console.log('this i, this j, nextIJ ',this.i, this.j, this.goNextIJ);
     if(this.i==this.goNextIJ[0]&&this.j==this.goNextIJ[1]){
       //if we're in the destination hex, get  a new destination
       this.flying=false;
       this.goNextIJ=this.destinations.shift();
       //console.log(this.goNextIJ);
       if(this.checkHexforPath()){
         this.goNextIJ=this.destinations.shift();
         //console.log('got next dest ',this.goNextIJ);
       }
         this.goNextXY=hexToPixel(this.goNextIJ[0], this.goNextIJ[1]);
         this.timeMoving=0;
         this.startX=this.x;
         this.startY=this.y;
         let howFarI=abs(this.goNextIJ[0]-this.i);
         let howFarJ=abs(this.goNextIJ[1]-this.j);
         this.howFar=howFarI+howFarJ;
         this.howFarXY=dist(this.goNextXY[0],this.goNextXY[1],this.startX, this.startY);

     }//end was at IJ
}// end had destinations
else if(this.jumping && this.status=='playing'){
  if (this.x==this.goNextXY[0] && this.y==this.goNextXY[1]){
    this.jumping=false;
  }
}


if (this.x != this.goNextXY[0] || this.y!=this.goNextXY[1]){
//we're not there yet
this.timeMoving+=deltaTime;
let ease=easeInOutSine(min(this.timeMoving/(this.speed*this.howFar),1));
if(this.flying){
  this.z=sin(PI*ease)*(this.howFarXY*0.75);
  //we use this when drawing the player sprite so as not to affect the shadow
}
this.x=lerp(this.startX, this.goNextXY[0],ease);
this.y=lerp(this.startY, this.goNextXY[1],ease);
}else{
  this.flying=false;
  this.z=max(0, floor(this.z*0.75));
  if(this==gameP.whoseTurn){this.z+=+(sin(millis()/500)*2)}
}

//end  moving

  }//end show

}//end class
